/*
 * Copyright 2020 The gRPC Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package io.grpc.binder.internal;

import com.google.common.testing.EqualsTester;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.robolectric.RobolectricTestRunner;

@RunWith(RobolectricTestRunner.class)
public final class BoundClientAddressTest {

  private static final int MY_UID = 1234;
  private static final int OTHER_UID = 1235;
  private static final int OTHER_UID_2 = 1236;

  @Test
  public void testEquality() {
    new EqualsTester()
        .addEqualityGroup(new BoundClientAddress(MY_UID), new BoundClientAddress(MY_UID))
        .addEqualityGroup(new BoundClientAddress(OTHER_UID))
        .addEqualityGroup(new BoundClientAddress(OTHER_UID_2))
        .testEquals();
  }
}
